function love.load()
    math.randomseed(os.time())
    math.random(); math.random(); math.random()
    love.window.setTitle("Light and Shadow")
    love.window.setMode(800, 640)
    love.graphics.setBackgroundColor(232, 187, 100)
    mousex, mousey = 32, 32
    places = {}
    for i = 1, 19, 1 do
        row = {}
        for l = 1, 19, 1 do
            table.insert(row, "empty")
        end
        table.insert(places, row)
    end
    whites = 0
    blacks = 0
    ended = false
    font = love.graphics.newFont(36)
end

function love.update(dt)
    for i = 1, #places, 1 do
        for l = 1, 19, 1 do
            freedoms = 0
           if places[i][l] == "black" then
                if i > 1 then
                    if places[i - 1][l] == "empty" or places[i - 1][l] == "black" then
                        freedoms = freedoms + 1
                    end
                end
                if i < 19 then
                    if places[i + 1][l] == "empty" or places[i + 1][l] == "black" then
                        freedoms = freedoms + 1
                    end
                end
                if l > 1 then
                    if places[i][l - 1] == "empty" or places[i][l - 1] == "black" then
                        freedoms = freedoms + 1
                    end
                end
                if l < 19 then
                    if places[i][l + 1] == "empty" or places[i][l + 1] == "black" then
                        freedoms = freedoms + 1
                    end
                end
                if freedoms == 0 then
                    places[i][l] = "white"
                end
           end
           if places[i][l] == "white" then
                if i > 1 then
                    if places[i - 1][l] == "empty" or places[i - 1][l] == "white" then
                        freedoms = freedoms + 1
                    end
                end
                if i < 19 then
                    if places[i + 1][l] == "empty" or places[i + 1][l] == "white" then
                        freedoms = freedoms + 1
                    end
                end
                if l > 1 then
                    if places[i][l - 1] == "empty" or places[i][l - 1] == "white" then
                        freedoms = freedoms + 1
                    end
                end
                if l < 19 then
                    if places[i][l + 1] == "empty" or places[i][l + 1] == "white" then
                        freedoms = freedoms + 1
                    end
                end
                if freedoms == 0 then
                    places[i][l] = "black"
                end
           end
       end
   end
end

function love.draw()
    love.graphics.setColor(130, 83, 21)
    for i = 1, 19, 1 do
        love.graphics.line(i * 32, 32, i * 32, 608)
    end
    for i = 1, 19, 1 do
        love.graphics.line(32, i*32, 608, i*32)
    end
    love.graphics.setColor(255, 255, 255, 120)
    love.graphics.circle("fill", mousex, mousey, 15)
    whites = 0
    blacks = 0
    for i = 1, #places, 1 do
        for l = 1, 19, 1 do
            if places[i][l] == "white" then
                love.graphics.setColor(255, 255, 255)
                love.graphics.circle("fill", i * 32, l * 32, 15)
                whites = whites + 1
            end
            if places[i][l] == "black" then
                love.graphics.setColor(0, 0, 0)
                love.graphics.circle("fill", i * 32, l * 32, 15)
                blacks = blacks + 1
            end
        end
    end
    if whites + blacks == 361 then
        ended = true
    end
    love.graphics.setFont(font)
    love.graphics.setColor(255, 255, 255)
    love.graphics.print(whites, 640, 30)
    love.graphics.setColor(0, 0, 0)
    love.graphics.print(blacks, 640, 90)
    love.graphics.setColor(255, 255, 255)
end

function love.keypressed(key)
    if key == "escape" then
        love.event.quit()
    end
    if key == "r" then
        love.load()
    end
end

function love.mousemoved(mx, my, dx, dy)
    if mx%32 < 16 then
        mousex = mx - mx%32
    end
    if mx%32 > 16 then
        mousex = mx + 32 - mx%32
    end
    if my%32 < 16 then
        mousey = my - my%32
    end
    if my%32 > 16 then
        mousey = my + 32 - my%32
    end
    if mousex < 32 then
        mousex = 32
    end
    if mousex > 608 then
        mousex = 608
    end
    if mousey < 32 then
        mousey = 32
    end
    if mousey > 608 then
        mousey = 608
    end
end

function love.mousepressed(mx, my, button)
    if not ended then
        px = mousex / 32
        py = mousey / 32
        if places[px][py] == "empty" then
            places[px][py] = "white"
            rand = math.random(4)
            loop = true
            count = 0
            while loop do
            if rand == 1 then
                if px < 19 then
                    if places[px + 1][py] == "empty" then
                        places[px + 1][py] = "black"
                        loop = false
                    else
                        count = count + 1
                        if count >= 4 then
                            loop = false
                        else
                            rand = 2
                        end 
                    end
                else
                    count = count + 1
                    if count >= 4 then
                        loop = false
                    else
                        rand = 2
                    end
                end 
            end
            if rand == 2 then
                if py < 19 then
                    if places[px][py + 1] == "empty" then
                        places[px][py + 1] = "black"
                        loop = false
                    else
                        count = count + 1
                        if count >= 4 then
                            loop = false
                        else
                            rand = 3
                        end
                    end
                else    
                    count = count + 1
                    if count >= 4 then
                        loop = false
                    else
                        rand = 3
                    end
                end
            end
            if rand == 3 then
                if px > 1 then
                    if places[px - 1][py] == "empty" then
                        places[px - 1][py] = "black"
                        loop = false
                    else
                        count = count + 1
                        if count >= 4 then
                            loop = false
                        else
                           rand = 4
                        end
                    end
                else
                    count = count + 1
                    if count >= 4 then
                        loop = false
                    else
                       rand = 4
                    end
                end
            end
            if rand == 4 then
                if py > 1 then
                    if places[px][py - 1] == "empty" then
                        places[px][py - 1] = "black"
                        loop = false
                    else
                        count = count + 1
                        if count >= 4 then
                            loop = false
                        else
                           rand = 1
                        end
                    end
                else
                    count = count + 1
                    if count >= 4 then
                        loop = false
                    else
                        rand = 1
                    end
                end
            end
            end
        end
    else
        ended = false
        love.load()
    end
end
